<?php
/**
* Amazing System
**/

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

require_once( AMSYS_PLUGIN_PATH . 'includes/shortcode-switch.php' );
require_once( AMSYS_PLUGIN_PATH . 'includes/shortcode-block.php' );
require_once( AMSYS_PLUGIN_PATH . 'includes/shortcode-get-current-version.php' );

if ( is_admin() ) {
	require AMSYS_PLUGIN_PATH . 'includes/tinymce-button.php';
	require AMSYS_PLUGIN_PATH . 'includes/meta-thank-you.php';
}

class MagicAmazingSystemPlugin {

	public static $javascript = '';
	public static $request = array();
	public static $blog_charset = '';
	
	public static $check_update = '';

	/**
	* Define Class Constants
	*/
	const default_shortcode_name = 'as';
	const option_key = 'amazing_system_shortcode';

	/**
	 * Save Get/Post/Session to class var for later use
	 */
	public static function save_request_vars() {
		static $charset = 'ASCII, UTF-8, ISO-8859-1, JIS, EUC-JP, SJIS';

		self::$blog_charset = get_option( 'blog_charset' );

		/* getting mago vars */
		if(isset($_GET['targetId']))
		{
			$target_id = $_GET['targetId'];
			$ch = curl_init();

			curl_setopt($ch, CURLOPT_URL, "https://mago.co/MCF/Form/GetFormData?formId=6a47207a-9f56-430f-9e36-1459ed99c357&targetId=$target_id");
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	
			$data = curl_exec($ch);
			$myArray = json_decode($data, true);
			curl_close($ch);
			foreach ($myArray AS $key => $value) {
				if($key == 'contactdateofperformance'){
					preg_match('/\((\d+)\)/', $value, $matches);
					$timestamp = $matches[1] / 1000;

					// Format the timestamp
					$value = date('l, F j, Y', $timestamp);
					
				}
				if (is_array($value)) {
					$sub = new JSONObject;
					$sub->set($value);
					$value = $sub;
				}
				$_GET[$key] = $value;
			}			
		}


		$data = array();
		$data = isset( $_GET ) ? array_merge( $data, $_GET ) : $data;
		$data = isset( $_POST ) ? array_merge( $data, $_POST ) : $data;

		$clean_data = array();

		foreach ( $data as $key => $value ) {
			$clean_data[ $key ] = self::convert_encoding_deep(
				$value,
				self::$blog_charset,
				$charset
				);
		}

		self::$request = stripslashes_deep( $clean_data );
	}

	public static function convert_encoding_deep( $value, $blog_charset = false, $charset = 'ASCII, UTF-8, ISO-8859-1, JIS, EUC-JP, SJIS' )	{
		if ( false === $blog_charset ) {
			$blog_charset = self::$blog_charset;
		}
		if ( is_array( $value ) ) {
			$value = array_map( 'MagicAmazingSystemPlugin::convert_encoding_deep', $value );
		} elseif ( is_string( $value ) && function_exists( 'mb_convert_encoding' ) ) {
			$value = mb_convert_encoding(
				$value,
				$blog_charset,
				$charset
				);
		}

		return $value;
	}

		/**
		* Register used shortcodes
		*/
		public static function register_shortcodes()	{

			$settings = get_option( 'amsys_settings' );
			$basic_merge_shortcode = $settings['basic_merge_shortcode'] ? $settings['basic_merge_shortcode'] : 'as';

			add_shortcode ( $basic_merge_shortcode, 'MagicAmazingSystemPlugin::shortcode_merge_handler' );
			add_shortcode ( 'gender', 'MagicAmazingSystemPlugin::as_shortcode_gender_cb' );
			add_shortcode ( 'show_as_form', 'MagicAmazingSystemPlugin::show_as_form_cb' );
			add_shortcode ( 'textarea', 'MagicAmazingSystemPlugin::textarea_cb');
			add_shortcode ( 'switch', 'as_switch_shortcode_cb');
			add_shortcode ( 'as_plugin_server_version', 'as_get_current_version_shortcode_cb');
		}

		/**
		* Returns the content of a $_GET or $_POST or $_SESSION variable, referenced via shortcode, e.g. put the
		* following in the content of a post or page:
		*     [as what="Name" default="default value"]
		*/
		public static function shortcode_merge_handler( $atts ) {
			$default_atts = array(
				'what' => 'Name',
				'default' => ''
				);

			$settings = get_option( 'amsys_settings' );
			$shortcode_tag = $settings['basic_merge_shortcode'] ? $settings['basic_merge_shortcode'] : 'as';

			$atts = shortcode_atts( $default_atts, $atts, $shortcode_tag );

			$field = $atts[ 'what' ];
			$default_value = $atts[ 'default' ];

			if ( 'Name' == $field || 'name' == $field ) {
				return self::get_full_name( $default_value );
			}

			if ( 'firstname' == $field || 'mc-firstname' == $field ) {
				return self::get_firstname( $default_value );
			}

			if ( 'lastname' == $field || 'mc-lastname' == $field ) {
				return self::get_lastname( $default_value );
			}

			if ( isset( self::$request[ $field ] ) && !empty( self::$request[ $field ] ) ) {
				return trim( self::$request[ $field ] );
			}

			if ( self::is_a_default_1shop_field( $field ) ) {
				return self::shortcode_merge_handler( array(
						'what' => strtolower( $field ),
						'default' => $default_value
					) );
			}

			return $default_value;
		}

		/**
		 * Request field is a default 1ShoppingCart field
		 *
		 * 1SC in an update made all their standard fields lower case. We need
		 * to check if we are working with one of these fields and standardize
		 * the casing of the variable.
		 *
		 * @param  string  $field The `$_REQUEST` field
		 * @return boolean
		 */
		public static function is_a_default_1shop_field( $field ) {

			if ( $field === strtolower( $field ) ) {
				return false;
			}

			$fields = array(
				'email1',
				'company',
				'workphone',
				'homephone',
				'fax',
				'address1',
				'address2',
				'city',
				'state',
				'zip',
				'country'
			);

			$field = strtolower( $field );

			return in_array( $field, $fields, true );
		}

		/**
		 * Get client's full name
		 *
		 * Parse the request to build out the client's full name from avaliable fields.
		 *
		 * @param  string $default Value to use if unable to retrieve full name
		 * @return string          The value to replace the shortcode tag
		 */
		private static function get_full_name( $default ) {
			if ( self::get_firstname( false ) && self::get_lastname( false ) ) {
				return self::get_firstname( '' ) . ' ' . self::get_lastname( '' );
			} elseif ( self::get_firstname( false ) ) {
				return self::get_firstname( '' );
			}

			return $default;
		}

		/**
		 * Get client's first name
		 *
		 * Parse the request to build out the client's first name from avaliable fields.
		 *
		 * @param  string $default Value to use if unable to retrieve first name
		 * @return string          The value to replace the shortcode tag
		 */
		private static function get_firstname( $default ) {
            if ( isset( self::$request[ 'contactfirstname' ] ) && !empty( self::$request[ 'contactfirstname' ] ) ) {
                return trim( self::$request[ 'contactfirstname' ] );
            }

			if ( isset( self::$request[ 'mc-firstname' ] ) && !empty( self::$request[ 'mc-firstname' ] ) ) {
				return trim( self::$request[ 'mc-firstname' ] );
			}

			if ( isset( self::$request[ 'Name' ] ) && !empty( self::$request[ 'Name' ] ) ) {
				$name_array = explode( ' ', self::$request[ 'Name' ] );
				return trim( $name_array[0] );
			}

			return $default;
		}

		/**
		 * Get client's last name
		 *
		 * Parse the request to build out the client's last name from avaliable fields.
		 *
		 * @param  string $default Value to use if unable to retrieve last name
		 * @return string          The value to replace the shortcode tag
		 */
		private static function get_lastname( $default ) {
                if ( isset( self::$request[ 'contactlastname' ] ) && !empty( self::$request[ 'contactlastname' ] ) ) {
                    return trim( self::$request[ 'contactlastname' ] );
                }

				if ( isset( self::$request[ 'mc-lastname' ] ) && !empty( self::$request[ 'mc-lastname' ] ) ) {
					return trim( self::$request[ 'mc-lastname' ] );
				}

				if ( isset( self::$request[ 'Name' ] ) && !empty( self::$request[ 'Name' ] ) ) {
					$name_array = explode( ' ', self::$request[ 'Name' ], 2 );
					if ( 2 > count( $name_array ) ) {
						return $default;
					}
					return trim( $name_array[1] );
				}

				return $default;
		}

	/**
	 * TODO: change 'req' to pull from an option
	 */
	public static function as_shortcode_gender_cb ( $atts, $content = null ) {
		extract( shortcode_atts( array(
			'boy' => 'he',
			'girl' => 'she',
			'multi' => 'they',
			'req' => 'field8',
		), $atts ) );

		$r = $boy;
		$request = array();
		$request = self::$request;

		if ( isset( $request[$req] ) && 'girl' == $request[$req] ) {
			return $girl;
		}
		if ( isset( $request[$req] ) && 'multi' == $request[$req] ) {
			return $multi;
		}

		return $r;
	}

	/**
	 * Handler for [show_as_form] shortcode.
	 */
	public static function show_as_form_cb( $atts, $content = null) {
		global $post;
		$as_form_html_value = get_post_meta( $post->ID, '_as_the_form', true);

		if ( '' == $as_form_html_value ) {
			return $content;
		}

		/**
		 * WordPress function `is_plugin_active` only in "admin" area
		 *
		 * To do this test on the front end (as we are in this short code)
		 * we have to make sure the file containing the function is loaded.
		 *
		 * GitHub: Issue #4
		 */
		if ( !function_exists( 'is_plugin_active' ) ) {
			include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
		}
		if ( is_plugin_active( 'kswp_pop_wizard/kswp_pop_wizard.php' ) ) {
			global $kswp_pop_wizard_var;
			$as_form_html_value = $kswp_pop_wizard_var->kswp_pop_wizard_tooltip_html_js( $as_form_html_value );
		}

		//using old do_shortcode
		return MagicAmazingSystemPlugin::tkst_shortcodes($as_form_html_value);
		//return do_shortcode($as_form_html_value);
		//return apply_filters( "the_content", $as_form_html_value);

		}


	public static function thecontent( $content)

	{

		$settings = get_option( 'amsys_settings' );
		if ( isset( $settings['basic_merge_shortcode'] ) && !empty( $settings['basic_merge_shortcode']) ) {

			$shortcode = $settings['basic_merge_shortcode'];

		} else {

			$shortcode = 'as';

		}
		$field='what';

		$default = 'default';
        $pattern = '~\[\s*as\s*what\s*=\s*[\'"]?(\w*)\s*[\'"]?(?:\s*default\s*=\s*[\'"]?(\w*)\s*[\'"]?)?\]~';

        $content = preg_replace($pattern, "[".$shortcode." ".$field."='$1' ".$default."='$2' ]", $content, -1, $count);
		//using old do_shortcode

		//$content = MagicAmazingSystemPlugin::tkst_shortcodes($content);
		//$content = do_shortcode( $content );
		return $content;

	}


	/* do_shortcode */
	public static function tkst_shortcodes( $content, $ignore_html = false ) {
		global $shortcode_tags;

		if ( false === strpos( $content, '[' ) ) {
			return $content;
		}
		if (empty($shortcode_tags) || !is_array($shortcode_tags))
			return $content;

		$tagnames = array_keys($shortcode_tags);
		$tagregexp = join( '|', array_map('preg_quote', $tagnames) );
		$pattern = "/\\[($tagregexp)/s";

		if ( 1 !== preg_match( $pattern, $content ) ) {
			// Avoids parsing HTML when there are no shortcodes or embeds anyway.
			return $content;
		}


		//$content = do_shortcodes_in_html_tags( $content, $ignore_html );
		$pattern = get_shortcode_regex();
		$content = preg_replace_callback( "/$pattern/s", 'do_shortcode_tag', $content );
		// Always restore square braces so we don't break things like <!--[if IE ]>

		// Clean up entire string, avoids re-parsing HTML.
	    $trans = array( '&#91;' => '[', '&#93;' => ']' );

		$content = strtr( $content, $trans );
		return $content;

	}


	/**
	 * Handler for [textarea][/textarea] shortcode
	 *
	 * When using the standard HTML tag for textareas, the containing
	 * form get broken out of. This shortcode will create a normal
	 * textarea tag when viewed in the page output, but stops the problem
	 * in the admin area.
	 *
	 * @param  array $atts    attributes contained in opening tag
	 * @param  string $content data contained between open and closed [textarea][/textarea]
	 * @return string          the html output
	 */
	public static function textarea_cb( $atts, $content = '') {
		$atts = shortcode_atts( array(

			// textarea specific
			'autofocus' => '',
			'cols' => '',
			'disabled' => '',
			'form' => '',
			'maxlength' => '',
			'name' => '',
			'placeholder' => '',
			'readonly' => '',
			'required' => '',
			'rows' => '',
			'wrap' => '',

			// global attributes
			'accesskey' => '',
			'class' => '',
			'contenteditable' => '',
			'contextmenu' => '',
			'dir' => '',
			'draggable' => '',
			'dropzone' => '',
			'hidden' => '',
			'id' => '',
			'lang' => '',
			'spellcheck' => '',
			'style' => '',
			'tabindex' => '',
			'title' => '',

			// event attributes
			'onblur' => '',
			'onchange' => '',
			'oncontextmenu' => '',
			'onfocus' => '',
			'onformchange' => '',
			'onforminput' => '',
			'oninput' => '',
			'oninvalid' => '',
			'onselect' => '',
			'onsubmit' => '',
			'onkeydown' => '',
			'onkeypress' => '',
			'onkeyup' => '',
			'onclick' => '',
			'ondblclick' => '',
			'ondrag' => '',
			'ondragend' => '',
			'ondragenter' => '',
			'ondragleave' => '',
			'ondragover' => '',
			'ondragstart' => '',
			'ondrop' => '',
			'onmousedown' => '',
			'onmousemove' => '',
			'onmouseout' => '',
			'onmouseover' => '',
			'onmouseup' => '',
			'onmousewheel' => '',
			'onscroll' => '',
		), $atts );

		$atts_string = '';

		if ( !empty($atts) ) {
			foreach ($atts as $k => $v) {
				$append = '';

				if ( '' != $v ) {
					$append = ' ' . $k . '="' . esc_attr( $v ) . '"';
				}

				$atts_string .= $append;
			} // End foreach
		} // End If

		$return = '<textarea' . $atts_string . '>' . esc_textarea( do_shortcode( $content ) ) . '</textarea>';
		return $return;
	}

	// Used to uniquely identify this plugin's menu page in the WP manager
	const admin_menu_slug = 'amazing_system';

	/**
	* Create admin menue
	*/
	public static function create_admin_menu() {
			add_menu_page(
				'Amazing Mago Administration',		// page title
				'Amazing Mago',		// menu title
				'manage_options',		// capability
				self::admin_menu_slug,	// menu slug
				'MagicAmazingSystemPlugin::get_admin_page'	// callback
				);
	}

	/**
	* Prints the admininstration page for plugin.
	*/
	public static function get_admin_page()	{
		$settings = get_option( 'amsys_settings' );

		if ( !empty($_POST) && check_admin_referer('amazing_system_options_update','amazing_system_admin_nonce') && current_user_can('manage_options') )		{
                    
//        			update_option( 'mago_api_key', $_POST['mago_api_key'] );
					$settings['mago_api_key'] = $_POST['mago_api_key'];
                        
			$settings['basic_merge_shortcode'] = stripslashes($_POST['shortcode_name']);
			$settings['1shop_fields'] = stripslashes_deep( $_POST['merge_fields'] );
			update_option( 'amsys_settings', $settings );
			$msg = '<div class="updated"><p>Your settings have been <strong>updated</strong></p></div>';
		}

		$basic_merge_shortcode = $settings['basic_merge_shortcode'] ? $settings['basic_merge_shortcode'] : 'as';

		$shortcode_name = esc_attr( $basic_merge_shortcode );
		unset($basic_merge_shortcode);
		include( AMAZINGSYSTEM_PLUGIN_DIR . 'includes/admin_page.php' );
	}

	/**
	* The inputs here come directly from WordPress:
	* @param	array	$links - a hash in the format of name => trnaslation e.g.
	* 	array('deactivate' => 'Deactivate') that describes all links available to a plugin.
	* @param	string	$file - the path to a plugin's main file (the one with the info header),
	*	relative to the plugins directory, e.g. 'amazing-system/index.php'
	* @return	array	The $links hash.
	*/
	public static function add_plugin_settings_link($links, $file) {
		if ( $file == 'amazing-system/amazing-system.php' ) {
			$settings_link = sprintf ( '<a href="%s">%s</a>', admin_url ( 'admin.php?page='.self::admin_menu_slug ), 'Settings' );
			array_unshift ( $links, $settings_link );
		}
		return $links;
	}

	/**
	 * Hooks into 'the_content' filter to stop wpautop.
	 *
	 * wpautop is the special WordPress filter that changes
	 * HTML in posts/pages so you don't break you website.
	 * In some cases we want to do advanced things inside
	 * a post or page. This will let us.
	 *
 	 * @param  string $content recieved from 'the_content' filter, not used
	 * @return string $content return content back to WordPress (unchanged)
	 */
	 public static function stop_html_filter( $content ) {
		global $post;
		$as_filter_html_value = get_post_meta($post->ID, '_as_filter_html', true);

		if ( '' != $as_filter_html_value && 'on' == $as_filter_html_value ) {
			remove_filter('the_content', 'wpautop');
			remove_filter('the_excerpt', 'wpautop');
			remove_filter('the_content', 'wptexturize');
			remove_filter('the_excerpt', 'wptexturize');
		}
		return $content;
	}

	public static function add_javascript_to_footer($content) {
		global $post;

		$as_extra_js_value = get_post_meta( $post->ID, '_as_extra_js', true);
		$as_extra_js_value = do_shortcode( $as_extra_js_value );

		if ( '' == $as_extra_js_value ) {
			return $content;
		}

		$javascript = <<<EOF
		<script type="text/javascript">
		/* <![CDATA[ */
		$as_extra_js_value
		/* ]]> */
		</script>
EOF;

		self::$javascript = $javascript;
		add_action('wp_footer', 'MagicAmazingSystemPlugin::js_footer_callback', 20 );
		return $content;
	}

	public static function js_footer_callback() {
		echo self::$javascript;
	}

	/* Check for self hosted updates of plugin */
	public static function activated($path){


		//Update check parameters
		$hash = 'b09aea28f6e9a92c3f4fc4dcf2c30a72';
		$plugin_current_version = AMSYS_VERSION;
		$plugin_remote_path = AMSYS_REMOTE.'?asysu-amazing-system-update='.$hash;	
		$plugin_slug = AMSYS_BASE;
		$license_user = '';
		$license_key = '';
		
		$actual_link = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
		

		if ( strpos($actual_link,'plugins.php') !== false || strpos($actual_link,'update-core.php') !== false ) {
 
			$remote_version = self::getRemote_version($plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key );


			if( $remote_version->is_active ){
				update_option('amsysu_activation_check', '');
			} else {
				update_option('amsysu_activation_check', 'nah');
			}

		}

		if( !function_exists('deactivate_plugins')){
			require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
		}


//		if ( get_option('amsysu_activation_check', '') == 'nah' ) {

//

//			deactivate_plugins( plugin_basename($path), true);

//

//			$splink = 'http://support.amazingsystem.com';

//

//			wp_die( 'Your access to the Amazing System plugin has been limited. Please contact support for more information: <a href="'.$splink.'">'.$splink.'</a>' );

//

//		}

	}

	/**
	 * Return the remote version
	 * @return string $remote_version
	 */
	public static function getRemote_version($version, $url, $slug, $license_user='', $license_key='')
	{
		$params = array(
			'body' => array(
				'action' => 'version',
				'license_user' => '',
				'license_key' => '',
				'domain' => home_url(),
				'email' => get_bloginfo('admin_email'),
			),
		);
		$request = wp_remote_post ($url, $params );

	
		if ( !is_wp_error( $request ) || wp_remote_retrieve_response_code( $request ) === 200 ) {
			return unserialize( $request['body'] );
		} else {

			$obj = new stdClass();
			$obj->new_version = 0;
			$obj->active = true;
			$obj->status = false;

			return $obj;
		}
	}

	/* Check for self hosted updates of plugin */
	public static function check_update(){

		//Update check parameters
		$hash = 'b09aea28f6e9a92c3f4fc4dcf2c30a72';
		$plugin_current_version = AMSYS_VERSION;
		$plugin_remote_path = AMSYS_REMOTE.'?asysu-amazing-system-update='.$hash;	
		$plugin_slug = AMSYS_BASE;
		$license_user = '';
		$license_key = '';
		
//		if ( get_option('amsysu_activation_check', '') == 'nah' ) {

//

//

//

//			if( !function_exists('deactivate_plugins')){

//

//				require_once( ABSPATH . 'wp-admin/includes/plugin.php' );

//

//			}

//

//			deactivate_plugins( plugin_basename(AMSYS_PLUGIN_FILE), true);

//

//			return false;

//

//		}
		//Check Updates
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/check-update.php';
		self::$check_update = new Magic_Amazing_System_Update($plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key );

	}


}

add_action( 'wp_enqueue_scripts', 'amsys_maybe_enqueue_validator' );
function amsys_maybe_enqueue_validator () {
	global $post;

	wp_register_script( 'amsys-gen4-validator', plugins_url( 'js/gen_validatorv4.js', AMSYS_PLUGIN_FILE ), array(), '4.0', true );

	if ( is_singular() ) {
		$scripts = get_post_meta( $post->ID, '_as_test_multicheckbox', false );

		foreach ($scripts as $script) {
			if ( wp_script_is( $script, 'registered' ) ) {
				wp_enqueue_script( $script );
			}
		}
	}
}


add_filter('the_content', 'MagicAmazingSystemPlugin::stop_html_filter', 9);
add_filter('the_content', 'MagicAmazingSystemPlugin::add_javascript_to_footer', 9);

add_action( 'init', array( 'AmSys_Shortcode_Block', 'get_instance' ) );

require_once( AMSYS_PLUGIN_PATH . 'includes/meta-box/example-functions.php' );
